/*
Fonksiyon Çözümleme Sınıfı v0.0.2
İstenen fonksiyonu çözümler değerlere göre sonucu hesaplar.
Copyright (C) 2004 Engin KUZU
www.enginkuzu.org	enginkuzu@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

//http://www.gnu.org/copyleft/gpl.html
//Turkce cevirisi: http://www.belgeler.org/howto/gpl_copy.html

/*		Teknik Bilgiler:

Sıralama Bilgisi:

	ilk başlangıç       --->  [sayı] ( cos( sin( tan( log( + - x
          (             --->  [sayı] ( cos( sin( tan( log( + - x
	   [sayı] x )       --->  ) ^ + - * /
	^ + - * /           --->  ( x [sayı] cos( sin( tan( log(


Çözümlenmiş Bilgi:

sayı =	a	( Ayrıca sayının başladığı ilk yerin adresi de sonuna eklenir.)
x	 =	b
(	 =	c
)	 =	d
cos( =	e
sin( =	f
tan( =	g
log( =	h
+	 =	i
-	 =	j
*	 =	k
/	 =	l
^	 =	m

 */
 
//Sınıf ismi : fx
//Değişik Zamanlarda Yapılan İşler:
//
//
// v 0.0.2 13.08.2005 16:14
// Doğruluk denetleme, çözümleme, çözüm ilerletme sorunsuz. ?!
// Hesaplama metodu sorunsuz. ?!
// Analiz aşaması daha çok hızlandırılabilir fakat büyük kısmı yeniden yazılmalı.
// Birçok hata temizlendi, iyileştirme yapıldı.
// İzin verilenler : () + - * / ^ cos() sin() tan() log() x tamsayı(271), kesirli sayılar(1.923).
// Örnek : 2*(x-7*cos(x-1)-1)^2+2*x*(x-7)+46*x+11/(x-1)+1
//

using System;

public static class fx
{
	private static double[] sabit;
	private static short[] islem;

	
	public static bool cozumle(string dizi)
	{
		int boy = dizi.Length;
		
		bool sorunsuz=false;
		int i = 0;
		
		int psayac=0;	//parantezleri sayar;
		string cozumleme="";
		int yer;
		char k;
		
		//Sonsuz çevrim içinde girilen dizinin uygun
		//formatta yazılıp yazılmadığı kontrol ediliyor.
		while(true)
		{
			//İşlem sonu kontrolü
			if ( boy == i )
			{
				if ( boy == 0 )
					sorunsuz = false;
				else
					sorunsuz = true;
					
				break;
			}
			
			k = dizi[i];	//ilk karakteri k değişkenine al
			//Console.WriteLine("Bulundu : {0}",k); 
			
			//Dizi başlangıcı özel durumu
			if ( i == 0 )
			{
				if ( k < 58 && k > 47 )	//[sayı] ile başlama durumu
				{
					yer=i;
					i++;
					if ( boy == i )
					{
						cozumleme+="a"+Convert.ToString(yer);
						sorunsuz=true;
						break;
					}
					
					while( boy > i && dizi[i]<58 && dizi[i]>47 )
						i++;
					if ( boy == i )
					{
						cozumleme+="a"+Convert.ToString(yer);
						sorunsuz=true;
						break;
					}
					
					if( dizi[i] == '.' && boy > i+1 )
					{
						i++;
						while( boy > i && dizi[i]<58 && dizi[i]>47 )
							i++;
						if ( boy == i )
						{
							cozumleme+="a"+Convert.ToString(yer);
							sorunsuz=true;
							break;
						}
						cozumleme+="a"+Convert.ToString(yer);
						continue;
					}
					else
					{
						if ( boy == i+1 )
						{
							sorunsuz=false;
							break;
						}
						else
						{
							cozumleme+="a"+Convert.ToString(yer);
							continue;
						}
					}
				}
				
				if ( k == '+' || k == '-' )	// + veya - ile başlama durumu
				{
					i++;
					if ( boy == i )
					{
						sorunsuz=false;
						break;
					}
					else if ( k == '+' )
						cozumleme+="i";
					else
						cozumleme+="j";
					continue;
				}
				
				if ( k == 'x' )	// x ile başlama durumu
				{
					i++;
					cozumleme+="b";
					continue;
				}
				
				if ( k == '(' ) // ( ile başlama durumu
				{
					if ( boy > i+2 )
					{
						i++;
						psayac++;
						cozumleme+="c";
						continue;
					}
					else
					{
						sorunsuz=false;
						break;
					}
				}
				
				if ( k == 'c' )	// cos( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'o' && dizi[i+2] == 's' && dizi[i+3] == '(' )
						{
							i+=4;
							psayac++;
							cozumleme+="e";
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 's' )	// sin( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'i' && dizi[i+2] == 'n' && dizi[i+3] == '(' )
						{
							i+=4;
							psayac++;
							cozumleme+="f";
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 't' )	// tan( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'a' && dizi[i+2] == 'n' && dizi[i+3] == '(' )
						{
							i+=4;
							psayac++;
							cozumleme+="g";
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 'l' )	// log( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'o' && dizi[i+2] == 'g' && dizi[i+3] == '(' )
						{
							i+=4;
							psayac++;
							cozumleme+="h";
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				//Tüm özel durumlara uymuyor ise hata vardır.
				sorunsuz=false;
				break;
			}
			
			//Dizi içindeki özel durumlar
			
			// [sayı] x veya ) 'den sonra ) ^ + - / * gelebilir.
			if ( ( dizi[i-1] < 58 && dizi[i-1] > 47 ) || dizi[i-1] == 'x' || dizi[i-1] == ')' )
			{
				if ( k == '^' || k == '+' || k == '-' || k == '/' || k == '*' )
				{
					if ( boy > i + 1 )
					{
						i++;
						if ( k == '^' )
							cozumleme+="m";
						else if ( k == '+' )
							cozumleme+="i";
						else if ( k == '-' )
							cozumleme+="j";
						else if ( k == '*')
							cozumleme+="k";
						else
							cozumleme+="l";
						continue;
					}
				}
				else if ( k == ')' )
				{
					i++;
					psayac--;
					cozumleme+="d";
					continue;
				}
				sorunsuz=false;
				break;
			}
			
			/*Galiba burası gereksiz....
			//Log( Cos( Sin( Tan( dan sonra + - x [sayı] gelme durumu
			if ( i > 3 && dizi[i-1] == '(' )
			{
				if ( dizi[i-2] == 'g' || dizi[i-2] == 'n' || dizi[i-2] == 's' )
				{
					if ( k == '+' || k == '-' )
					{
						if ( boy > i+2 )
						{
							i++;
							if ( k == '+' )
								cozumleme+="i";
							else
								cozumleme+="j";
							continue;
						}
						else
						{
							sorunsuz=false;
							break;
						}
					}
					if( k == 'x' )
					{
						if ( boy > i+1 )
						{
							i++;
							cozumleme+="b";
							continue;
						}
						else
						{
							sorunsuz=false;
							break;
						}
					}
					if ( k < 58 && k > 47 )	//[sayı] ile devam durumu
					{
						yer=i;
						i++;
					
						while( boy > i+1 && dizi[i]<58 && dizi[i]>47 )
							i++;
						
						if( dizi[i] == '.' && boy > i+2 )
						{
							i++;
							while( boy > i+1 && dizi[i]<58 && dizi[i]>47 )
								i++;
						}
						cozumleme+="a"+Convert.ToString(yer);
						continue;
					}
					sorunsuz=false;
					break;
				}
			}*/
			
			// ^ + - * / den sonra x ( [sayı] cos( sin( tan( log( gelebilir.
			if ( dizi[i-1] == '^' || dizi[i-1] == '+' || dizi[i-1] == '-' || dizi[i-1] == '*' || dizi[i-1] == '/' )
			{
				if ( k == 'x' )
				{
					i++;
					cozumleme+="b";
					continue;
				}
				if( k == '(' )
				{
					if ( boy > i+2 )
					{
						i++;
						cozumleme+="c";
						psayac++;
						continue;
					}
					else
					{
						sorunsuz=false;
						break;
					}
				}
				if ( k < 58 && k > 47 )	//[sayı] ile devam durumu
				{
					yer=i;
					i++;
				
					while( boy > i && dizi[i]<58 && dizi[i]>47 )
						i++;
						
					if ( boy == i )
					{
						cozumleme+="a"+Convert.ToString(yer);
						continue;
					}
					
					if( dizi[i] == '.' && boy > i+1 )
					{
						i++;
						while( boy > i && dizi[i]<58 && dizi[i]>47 )
							i++;
					}
					cozumleme+="a"+Convert.ToString(yer);
					continue;
				}
				if ( k == 'c' )	// cos( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'o' && dizi[i+2] == 's' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="e";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 's' )	// sin( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'i' && dizi[i+2] == 'n' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="f";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 't' )	// tan( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'a' && dizi[i+2] == 'n' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="g";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 'l' )	// log( ile başlama durumu
				{
					if ( boy > i+5 )
					{
						if ( dizi[i+1] == 'o' && dizi[i+2] == 'g' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="h";
							psayac++;
							continue;
						}
					}
				}
				sorunsuz=false;
				break;
			}
			
			// ( den sonra [sayi] ( cos( sin( tan( log( + - x gelme durumu
			if ( dizi[i-1] == '(' && boy > i+1 )
			{
				if ( k < 58 && k > 47 )	//[sayı] ile başlama durumu
				{
					yer=i;
					i++;

					while( boy > i+1 && dizi[i]<58 && dizi[i]>47 )
						i++;
					
					if( dizi[i] == '.' && boy > i+2 )
					{
						i++;
						while( boy > i+1 && dizi[i]<58 && dizi[i]>47 )
							i++;
					}
					cozumleme+="a"+Convert.ToString(yer);
					continue;
				}
				
				if ( k == '+' || k == '-' )	// + veya - ile başlama durumu
				{
					i++;
					if ( boy > i+1 )
					{
						if ( k == '+' )
							cozumleme+="i";
						else
							cozumleme+="j";
						continue;
					}
					else
					{
						sorunsuz=false;
						break;
					}
				}
				
				if ( k == 'x' )	// x ile başlama durumu
				{
					i++;
					if ( boy > i )
					{
						cozumleme+="b";
						continue;
					}
					else
					{
						sorunsuz=false;
						break;
					}
				}
				
				if ( k == '(' ) // ( ile başlama durumu
				{
					if ( boy > i+3 )
					{
						i++;
						cozumleme+="c";
						psayac++;
						continue;
					}
					else
					{
						sorunsuz=false;
						break;
					}
				}
				
				if ( k == 'c' )	// cos( ile başlama durumu
				{
					if ( boy > i+6 )
					{
						if ( dizi[i+1] == 'o' && dizi[i+2] == 's' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="e";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 's' )	// sin( ile başlama durumu
				{
					if ( boy > i+6 )
					{
						if ( dizi[i+1] == 'i' && dizi[i+2] == 'n' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="f";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 't' )	// tan( ile başlama durumu
				{
					if ( boy > i+6 )
					{
						if ( dizi[i+1] == 'a' && dizi[i+2] == 'n' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="g";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				
				if ( k == 'l' )	// log( ile başlama durumu
				{
					if ( boy > i+6 )
					{
						if ( dizi[i+1] == 'o' && dizi[i+2] == 'g' && dizi[i+3] == '(' )
						{
							i+=4;
							cozumleme+="h";
							psayac++;
							continue;
						}
					}
					sorunsuz=false;
					break;
				}
				//Tüm özel durumlara uymuyor ise hata vardır.
				sorunsuz=false;
				break;
			}
			//Tüm özel durumlara uymuyor ise hata vardır.
			sorunsuz=false;
			break;
		}
		
		if ( sorunsuz == true && psayac == 0)
			;
			//Console.WriteLine ("İşlem TAMAM.");
		else
		{
			//Console.WriteLine ("Girdide bir sorun var: {0}/{1}  :: psayac = {2}",i+1,boy,psayac);
			//Console.WriteLine ("Çözümleme Sonucu = {0}",cozumleme);
			return false;
		}
		//Console.WriteLine ("Çözümleme Sonucu = {0}",cozumleme);
		
		//sabit sayılar sayılmakta;
		int sayac = 0;
		foreach ( char x in cozumleme )
		{
			if ( x == 'a' )
				sayac++;	
		}
		//Console.WriteLine("{0} tane sayı var.",sayac);
		
		int sabitlerboyut=sayac+2;
		double[] sabitler = new double[sabitlerboyut];
		double gecici=0;
		bool noktadanonce;
		int noktayeri=0;
		
		for(i=0,sayac=1;i<cozumleme.Length;i++)
		{
			if ( cozumleme[i] == 'a' )
			{
				yer=0;
				i++;
				
				while ( i < cozumleme.Length && cozumleme[i] < 58 && cozumleme[i] > 47)
				{
					yer=yer*10+cozumleme[i]-48;
					i++;
				}
				i--;
				
				noktadanonce = true;
				gecici = 0;
				while ( yer < dizi.Length && ((dizi[yer] < 58 && dizi[yer] > 47) || dizi[yer] == '.') )
				{
					if ( dizi[yer] == '.' )
					{
						noktadanonce = false;
						noktayeri=yer;
						yer++;
						continue;
					}
					if ( noktadanonce )
					{
						gecici=gecici*10+(double)(dizi[yer]-48);
					}
					else
					{
						gecici=gecici+(double)(dizi[yer]-48)/(Math.Pow(10,(yer-noktayeri)));
					}
					yer++;
				}
				sayac++;
				sabitler[sayac]=gecici;
			}
		}
		
		//Console.WriteLine();
		//for (i=2;i<=sayac;i++)
			//Console.WriteLine("Sayı({0}) = {1}",i-1,sabitler[i]);
		sabitler[1]=-1;
		//sayac-1 kaç tane sayının olduğunu tutuyor.
		
		string yeni="";
		yer=2;
		for (i=0;i<cozumleme.Length;i++)
		{
			if ( cozumleme[i] == 'a' )
			{
				yeni=yeni+'z'+Convert.ToString(yer);
				yer++;
				i++;
				while( i<cozumleme.Length && cozumleme[i] < 58 && cozumleme[i] > 47)
				{
					i++;
				}
				i--;			
			}
			else if ( cozumleme[i] == 'b' )
			{
				yeni=yeni+"z0";
			}
			else
			{
				yeni=yeni+cozumleme[i];
			}
		}
		//Console.WriteLine("\n1.islem = {0}",yeni);
		
		string eski="";
		
		//yeni dizisine bakıp parantez sonrası + lar silinip,
		//parantez sonrası - ler sayi*(-1) olarak işleme konulacak.
		// z0 = x
		// z1 = -1 olarak ayrılmışlardır...
		
		for (i=0;i<yeni.Length;i++)
		{
			k = yeni[i];
			
			if (  i == 0 && k == 'j' )
			{
				eski=eski+"z1k";
				continue;
			}
			
			if ( k == 'c' || k == 'e' || k == 'f' || k == 'g' || k == 'h' )
			{
				if ( yeni[i+1] == 'i' )
				{
					eski=eski+k;
				}
				else if ( yeni[i+1] == 'j' )
				{
					eski=eski+k+"z1k";
				}
				else
				{
					eski=eski+k;
					i--;
				}
				i++;
			}
			else
			{
				eski=eski+k;
			}
		}
		//Console.WriteLine("2.islem = {0}\n",eski);
		
		
		sayac++;	//sabitler[sayac] sıradaki yer. izafi tabii.
		string islemler="";
		bool buldum = false ;
		bool bittimi = false;
		bool islemvar = false;
		int toplamaYeri = 0;
		int eski_boy ;
		int sayi1,sayi2;
		int ilk=0,son=0;
		char islemturu;
		
		int islemsayac = 0;
		//işlemler yapılıyor...
		do{
			bittimi = true;
		
			// z..^z.. arama çalışması
			buldum = true;
			i=0;
			sayi1=0;
			sayi2=0;
			ilk=0;
			son=0;
			eski_boy = eski.Length;
			while( true )
			{
				if ( islemvar )
				{
					eski_boy = eski.Length;
					i=0;
				}
				sayi1=0;
				sayi2=0;
				ilk=0;
				son=0;
				islemvar = false;
				
				for(;i<eski_boy;i++)
				{
					if ( eski[i] == 'z' )
					{
						ilk=i;
						i++;
						break;
					}
				}
				for(;i<eski_boy;i++)
				{
					if ( eski[i] < 58 && eski[i] > 47 )
					{
						sayi1=sayi1*10+eski[i]-48;
						continue;
					}
					else
						break;
				}
				if ( i == eski_boy )
					buldum=false;
					
				if ( i<eski_boy && eski[i] == 'm' && eski[i+1] == 'z' )
				{
					islemvar=true;
					i=i+2;
					for(;i<eski_boy;i++)
					{
						if ( eski[i] < 58 && eski[i] > 47 )
						{
							sayi2=sayi2*10+eski[i]-48;
							continue;
						}
						else
							break;
					}
					son=i;
					
					islemler=islemler+"^ "+Convert.ToString(sayi1)+" "+Convert.ToString(sayi2)+" "+Convert.ToString(sayac)+" ";
					yeni=eski;
					eski="";
					for(i=0;i<ilk;i++)
						eski=eski+yeni[i];
					eski=eski+'z'+Convert.ToString(sayac);
					sayac++;
					for(i=son;i<eski_boy;i++)
						eski=eski+yeni[i];
					bittimi = false;
					
					islemsayac += 4;
					//Console.WriteLine ("İşlem : {0}\n Eski : {1}",islemler,eski);

				}
				else
					islemvar=false;
					
				if ( !buldum )
					break;
			}//son
			
			// z..*z.. veya z../z.. arama çalışması
			buldum = true;
			i=0;
			sayi1=0;
			sayi2=0;
			ilk=0;
			son=0;
			eski_boy = eski.Length;
			while( true )
			{
				if ( islemvar )
				{
					eski_boy = eski.Length;
					i=0;
				}
				sayi1=0;
				sayi2=0;
				ilk=0;
				son=0;
				islemvar = false;
				
				for(;i<eski_boy;i++)
				{
					if ( eski[i] == 'z' )
					{
						ilk=i;
						i++;
						break;
					}
				}
				for(;i<eski_boy;i++)
				{
					if ( eski[i] < 58 && eski[i] > 47 )
					{
						sayi1=sayi1*10+eski[i]-48;
						continue;
					}
					else
						break;
				}
				if ( i == eski_boy )
					buldum=false;
					
				if ( i<eski_boy && ( eski[i] == 'k' || eski[i] == 'l' ) && eski[i+1] == 'z' )
				{
					islemturu=eski[i];
					islemvar=true;
					i=i+2;
					for(;i<eski_boy;i++)
					{
						if ( eski[i] < 58 && eski[i] > 47 )
						{
							sayi2=sayi2*10+eski[i]-48;
							continue;
						}
						else
							break;
					}
					son=i;
					
					//Hata düzeltme başlangıcı
					if ( ilk > 0 )
					{
						toplamaYeri = ilk - 1;
						if ( eski[toplamaYeri] == 'm' )
						{
							//işlem yapma,
							islemvar=false;
						}
					}
					if ( son < eski_boy )
					{
						toplamaYeri = son;
						if ( eski[toplamaYeri] == 'm' )
						{
							//işlem yapma,
							islemvar=false;
						}
					}

					if ( islemvar )
					{
						if ( islemturu == 'k' )
							islemturu = '*';
						else
							islemturu = '/';
						
						islemler=islemler+islemturu+" "+Convert.ToString(sayi1)+" "+Convert.ToString(sayi2)+" "+Convert.ToString(sayac)+" ";
						yeni=eski;
						eski="";
						for(i=0;i<ilk;i++)
							eski=eski+yeni[i];
						eski=eski+'z'+Convert.ToString(sayac);
						sayac++;
						for(i=son;i<eski_boy;i++)
							eski=eski+yeni[i];
						bittimi = false;
						
						islemsayac += 4;
						//Console.WriteLine ("İşlem : {0}\n Eski : {1}",islemler,eski);
					}
					//hata düzeltme sonu
				}
				else
					islemvar=false;
					
				if ( !buldum )
					break;
			}//son
			
			// z..+z.. veya z..-z.. arama çalışması
			buldum = true;
			i=0;
			sayi1=0;
			sayi2=0;
			ilk=0;
			son=0;
			eski_boy = eski.Length;
			while( true )
			{
				if ( islemvar )
				{
					eski_boy = eski.Length;
					i=0;
				}
				sayi1=0;
				sayi2=0;
				ilk=0;
				son=0;
				islemvar = false;
				
				for(;i<eski_boy;i++)
				{
					if ( eski[i] == 'z' )
					{
						ilk=i;
						i++;
						break;
					}
				}
				for(;i<eski_boy;i++)
				{
					if ( eski[i] < 58 && eski[i] > 47 )
					{
						sayi1=sayi1*10+eski[i]-48;
						continue;
					}
					else
						break;
				}
				if ( i == eski_boy )
					buldum=false;
					
				if ( i<eski_boy && ( eski[i] == 'i' || eski[i] == 'j' ) && eski[i+1] == 'z' )
				{
					islemturu=eski[i];
					islemvar=true;
					i=i+2;
					for(;i<eski_boy;i++)
					{
						if ( eski[i] < 58 && eski[i] > 47 )
						{
							sayi2=sayi2*10+eski[i]-48;
							continue;
						}
						else
							break;
					}
					son=i;
					
					//Hata düzeltme başlangıcı
					if ( ilk > 0 )
					{
						toplamaYeri = ilk - 1;
						if ( eski[toplamaYeri] == 'k' || eski[toplamaYeri] == 'l' || eski[toplamaYeri] == 'm' )
						{
							//işlem yapma,
							islemvar=false;
						}
					}
					if ( son < eski_boy )
					{
						toplamaYeri = son;
						if ( eski[toplamaYeri] == 'k' || eski[toplamaYeri] == 'l' || eski[toplamaYeri] == 'm' )
						{
							//işlem yapma,
							islemvar=false;
						}
					}

					if ( islemvar )
					{
						if ( islemturu == 'i' )
							islemturu = '+';
						else
							islemturu = '-';
				
						islemler=islemler+islemturu+" "+Convert.ToString(sayi1)+" "+Convert.ToString(sayi2)+" "+Convert.ToString(sayac)+" ";
						yeni=eski;
						eski="";
						for(i=0;i<ilk;i++)
							eski=eski+yeni[i];
						eski=eski+'z'+Convert.ToString(sayac);
						sayac++;
						for(i=son;i<eski_boy;i++)
							eski=eski+yeni[i];
						bittimi = false;
						
						islemsayac += 4;
						//Console.WriteLine ("İşlem : {0}\n Eski : {1}",islemler,eski);
					}
					//hata düzeltme sonu
					
				}
				else
					islemvar=false;
					
				if ( !buldum )
					break;
			}//son
		
			// (z) arama çalışması
			buldum = true;
			i=0;
			sayi1=0;
			sayi2=0;
			ilk=0;
			son=0;
			eski_boy = eski.Length;
			while( true )
			{
				if ( islemvar )
				{
					eski_boy = eski.Length;
					i=0;
				}
				sayi1=0;
				sayi2=0;
				ilk=0;
				son=0;
				islemvar = false;
				
				for(;i<eski_boy;i++)
				{
					if ( eski[i] == 'c' && eski[i+1] == 'z' )
					{
						ilk=i;
						i=i+2;
						break;
					}
				}
				for(;i<eski_boy;i++)
				{
					if ( eski[i] < 58 && eski[i] > 47 )
					{
						sayi1=sayi1*10+eski[i]-48;
						continue;
					}
					else
						break;
				}
				if ( i == eski_boy )
					buldum=false;
					
				if ( i<eski_boy && eski[i] == 'd' )
				{
					islemvar=true;
					i=i+1;
					son=i;
					
					yeni=eski;
					eski="";
					for(i=0;i<ilk;i++)
						eski=eski+yeni[i];
					eski=eski+'z'+Convert.ToString(sayi1);
					for(i=son;i<eski_boy;i++)
						eski=eski+yeni[i];
					bittimi = false;
					//Console.WriteLine ("İşlem : {0}\n Eski : {1}",islemler,eski);

				}
				else
					islemvar=false;
					
				if ( !buldum )
					break;
			}//son

			// cos(z) sin(z) tan(z) log(z) arama çalışması
			buldum = true;
			i=0;
			sayi1=0;
			sayi2=0;
			ilk=0;
			son=0;
			eski_boy = eski.Length;
			while( true )
			{
				if ( islemvar )
				{
					eski_boy = eski.Length;
					i=0;
				}
				sayi1=0;
				sayi2=0;
				ilk=0;
				son=0;
				islemvar = false;
				
				for(;i<eski_boy;i++)
				{
					if ( ( eski[i] == 'e' || eski[i] == 'f' || eski[i] == 'g' || eski[i] == 'h' ) && eski[i+1] == 'z' )
					{
						ilk=i;
						i=i+2;
						break;
					}
				}
				for(;i<eski_boy;i++)
				{
					if ( eski[i] < 58 && eski[i] > 47 )
					{
						sayi1=sayi1*10+eski[i]-48;
						continue;
					}
					else
						break;
				}
				if ( i == eski_boy )
					buldum=false;
					
				if ( i<eski_boy && eski[i] == 'd' )
				{
					islemturu = eski[ilk];
					islemvar=true;
					i=i+1;
					son=i;
					
					if ( islemturu == 'e' )
						islemturu = 'c';
					else if ( islemturu == 'f' )
						islemturu = 's';
					else if ( islemturu == 'g' )
						islemturu = 't';
					else
						islemturu = 'l';
						
					islemler=islemler+islemturu+" "+Convert.ToString(sayi1)+" "+Convert.ToString(sayac)+" ";
					yeni=eski;
					eski="";
					for(i=0;i<ilk;i++)
						eski=eski+yeni[i];
					eski=eski+'z'+Convert.ToString(sayac);
					sayac++;
					for(i=son;i<eski_boy;i++)
						eski=eski+yeni[i];
					bittimi = false;
					
					islemsayac += 3;
					//Console.WriteLine ("İşlem : {0}\n Eski : {1}",islemler,eski);

				}
				else
					islemvar=false;
					
				if ( !buldum )
					break;
			}//son
		
		}while( ! bittimi );
		
		// ÖNEMLİİİİİİİİİİİ
		//Console.WriteLine ("İşlem : {0}",islemler);
		
		//sonuçta elimizde bunlar var:
		// string	islemler =>	İşlem : * 0 5 11 * 7 8 12 - 2 3 13 + 9 10 14 c 11 15
 		// string	eski	 => Eski : z20			20=sayac-1 eder...
 		// sabitlerboyut double sabitler[] dizidsinin boyutudur.
		
		// doublesayilar : gerekli tüm double sabitler burada
		double[] doublesayilar = new double[sayac];
		for ( i=0;i<sabitlerboyut;i++)
			doublesayilar[i]=sabitler[i];
			
		// shortislem : gerekli işlem bilgisi bu 16 bit işaretli tamsayı değişkende tutulacak.
		//	+	-1		-	-2
		//	*	-3		/	-4
		//	^	-5
		//	c	-6		s	-7
		//	t	-8		l	-9
		short[] shortislem = new short[islemsayac];
		short sayi;
		int j=0;
		boy=islemler.Length;
		for ( i=0;i<boy;i++ )
		{
			k=islemler[i];
			if ( k == '+' )
				shortislem[j] = -1;
			else if ( k == '-' )
				shortislem[j] = -2;
			else if ( k == '*' )
				shortislem[j] = -3;
			else if ( k == '/' )
				shortislem[j] = -4;
			else if ( k == '^' )
				shortislem[j] = -5;
			else if ( k == 'c' )
				shortislem[j] = -6;
			else if ( k == 's' )
				shortislem[j] = -7;
			else if ( k == 't' )
				shortislem[j] = -8;
			else if ( k == 'l' )
				shortislem[j] = -9;
			else
			{
				sayi=0;
				for ( ; islemler[i]<58 && islemler[i]>47 ; i++)
				{
					sayi=(short)(sayi*10+islemler[i]-48);
				}
				shortislem[j] = sayi;
				i--;
			}
			i++;
			j++;
		}
		
		// SİL
		//for (i=0;i<islemsayac;i++)
		//	Console.WriteLine (shortislem[i]);

		//	doublesayilar sabitler var.
		//	doublesayilar[0]=x	doublesayilar[sayac-1] sonuç oluyor.
		//	
		//	shortislem de görevler var.
		//	shortislem[0] dan shortislem[islemsayac-1] e kadar.
		sabit=doublesayilar;
		islem=shortislem;
		return true;
	}
	
	public static bool hesapla(double x,out double y)
	{
		int sabitboy = sabit.Length;
		int islemboy = islem.Length ;
		int i;
		sabit[0]=x;
		
		for (i=0;i<islemboy;i++)
		{
			switch ( islem[i] )
			{
				case -1:
					sabit[islem[i+3]]=sabit[islem[i+1]]+sabit[islem[i+2]];
					i=i+3;
					break;
				case -2:
					sabit[islem[i+3]]=sabit[islem[i+1]]-sabit[islem[i+2]];
					i=i+3;
					break;
				case -3:
					sabit[islem[i+3]]=sabit[islem[i+1]]*sabit[islem[i+2]];
					i=i+3;
					break;
				case -4:
					if ( sabit[islem[i+2]] == 0 )	//Sıfıra bölme yapılamaz.
					{
						y=0;	return false;
					}
					sabit[islem[i+3]]=sabit[islem[i+1]]/sabit[islem[i+2]];
					i=i+3;
					break;
				case -5:
					sabit[islem[i+3]]=Math.Pow(sabit[islem[i+1]],sabit[islem[i+2]]);
					i=i+3;
					break;
				case -6:
					sabit[islem[i+2]]=Math.Cos(sabit[islem[i+1]]);
					i=i+2;
					break;
				case -7:
					sabit[islem[i+2]]=Math.Sin(sabit[islem[i+1]]);
					i=i+2;
					break;
				case -8:
					sabit[islem[i+2]]=Math.Tan(sabit[islem[i+1]]);
					i=i+2;
					break;
				case -9:
					if ( sabit[islem[i+1]] <= 0 )	//O ve negatif sayıların logaritması alınamaz.
					{
						y=0;	return false;
					}
					sabit[islem[i+2]]=Math.Log10(sabit[islem[i+1]]);
					i=i+2;
					break;
			}
		}
		if ( sabitboy == 2 )
			y=sabit[sabitboy-2];
		else
			y=sabit[sabitboy-1];
		//foreach (double xxx in sabit)
			//Console.WriteLine(xxx);
		return true;
	}
}
