using Gtk;
using Gdk;
using System;

public class hbox
{
	public bool cizildi = false;
	
	Entry fonksiyon;
	Button renk;
	HBox hb;
	
	Gdk.Color secilenRenk = new Gdk.Color (0, 0, 255);
	Gdk.GC gc;
	
	int xx;
	int yy;
	
	double xcarpan;
	double ycarpan;
	double xust;
	double yust;
	
	public hbox( VBox vb , string s )
	{
		hb = new HBox( false, 4);
		
		fonksiyon = new Entry( s );
		hb.PackStart( fonksiyon, true, true, 0);
		
		renk = new Button();
		renk.Clicked += new EventHandler(renk_sec);
		renk.SetSizeRequest(18,18);
		renk.ModifyBg (Gtk.StateType.Normal , secilenRenk );
		
		Frame fr = new Frame();
		fr.ShadowType = Gtk.ShadowType.Out ;
		fr.Add( renk );

		hb.PackStart( fr , false, false, 0);
		
		Button cizim = new Button("Çizime Başla");
		cizim.Clicked += new EventHandler(cizmeye_basla);
		hb.PackStart( cizim, false, false, 0);

		vb.PackStart( hb, false, false, 0);
	}
	public void yoket()
	{
		hb.Destroy();
	}
	public void renk_sec( object o, EventArgs args )
	{
		ColorSelectionDialog renkSecim = new ColorSelectionDialog ("Bir renk seçiniz");
		renkSecim.ColorSelection.HasPalette = true;			
		
		if ( renkSecim.Run () == (int) ResponseType.Ok)
		{
			secilenRenk = renkSecim.ColorSelection.CurrentColor;
			renk.ModifyBg( StateType.Normal, renkSecim.ColorSelection.CurrentColor );
			renk.ModifyFg( StateType.Normal, renkSecim.ColorSelection.CurrentColor );
		}
		
		renkSecim.Destroy();
	}
	public void cizmeye_basla(object o, EventArgs args )
	{
		DateTime t1 = new DateTime();
		DateTime t2 = new DateTime();
		
		t1 = DateTime.Now;
		ciz();
		t2 = DateTime.Now;
		
		TimeSpan tfark = t2 - t1;
		Console.WriteLine("Çizim Zamanı = {0}",tfark);
	}
	public void ciz()
	{
		int i;
		xx = FonksiyonCiz.en / 2;
		yy = FonksiyonCiz.boy / 2;
		
		if ( FonksiyonCiz.cizimbos )
		{
			FonksiyonCiz.pixmap.DrawLine(FonksiyonCiz.darea.Style.BlackGC, xx, yy, xx, (int)(yy*1.98) );
			FonksiyonCiz.pixmap.DrawLine(FonksiyonCiz.darea.Style.BlackGC, xx, yy, xx, (int)(yy*0.02) );
			FonksiyonCiz.pixmap.DrawLine(FonksiyonCiz.darea.Style.BlackGC, xx, yy, (int)(xx*0.02), yy);
			FonksiyonCiz.pixmap.DrawLine(FonksiyonCiz.darea.Style.BlackGC, xx, yy, (int)(xx*1.98), yy);
		
			for(i=xx%50;i<FonksiyonCiz.en;i+=50)
			{
				FonksiyonCiz.pixmap.DrawRectangle(FonksiyonCiz.darea.Style.BlackGC,true,i,yy-2,1,5);
			}
			for(i=yy%50;i<FonksiyonCiz.boy;i+=50)
			{
				FonksiyonCiz.pixmap.DrawRectangle(FonksiyonCiz.darea.Style.BlackGC,true,xx-2,i,5,1);
			}
			FonksiyonCiz.darea.QueueDraw();
			FonksiyonCiz.cizimbos=false;
		}

		string dizi = fonksiyon.Text;
		if ( !fx.cozumle(dizi) )
		{
			MessageDialog md = new MessageDialog ( null, DialogFlags.DestroyWithParent , MessageType.Error ,ButtonsType.Close ,"Fonksiyonu doğru girdiğinizden emin olun.");
			md.Run();
			md.Destroy();
			return;
		}
		
		gc = new Gdk.GC ( FonksiyonCiz.darea.RootWindow );
		Gdk.Color renk = secilenRenk;
		Gdk.Colormap cm = Gdk.Colormap.System;
		cm.AllocColor ( ref renk, true, true);
		gc.Foreground = renk;
		
		
		cizildi = true;
		
		xcarpan = FonksiyonCiz.sb1.Value;
		ycarpan = FonksiyonCiz.sb2.Value;
		xust = xx*xcarpan/50.0;
		yust = yy*ycarpan;
		//Console.WriteLine(xcarpan);
		
		if ( FonksiyonCiz.rb1.Active )
			akilli_cizim();
		else
			basit_cizim();
	}
	public void akilli_cizim()
	{
		double x1,i;	//i 2. x değeri yerine
		double y1,y2;
		double boy;
		double artim = xcarpan/50.0 ;

		
		for(i=-xust;;i+=artim)
		{
			if ( fx.hesapla(i,out y1) )
				if ( yust > Math.Abs(y1*50) )
				{
					x1=i;	//ilk nokta.
					break;
				}
		}
		
		for(;i<xust;i+=artim)
		{
			if ( fx.hesapla(i,out y2) )
			{
				if ( yust > Math.Abs(y2*50) )
				{
					boy=Math.Sqrt( Math.Pow( (i-x1)/xcarpan , 2 ) + Math.Pow( (y2-y1)/ycarpan , 2 ) );
					if ( boy < 0.014 )		//ÖNEMLİ
					{
						i-=artim;
						artim=artim*1.02;	//ÖNEMLİ
						continue;
					}
					if ( boy > 0.021 )		//ÖNEMLİ
					{
						i-=artim;
						artim=artim/1.02;	//ÖNEMLİ
						continue;
					}
					FonksiyonCiz.pixmap.DrawPoint( gc , (int)(i*50/xcarpan)+xx, (int)(-y2*50/ycarpan)+yy );
					//Console.WriteLine(boy);
				}
				x1=i;
				y1=y2;
			}
		}
		
		
	}
	public void basit_cizim()
	{		
		double i;	//x değeri yerine.
		double y;

		for(i=-xust;i<xust;i+=1/200.0 )	//eskisi /50.0 idi.
		{
			if ( fx.hesapla(i,out y) )
				FonksiyonCiz.pixmap.DrawPoint( gc , (int)(i*50/xcarpan)+xx, (int)(-y*50/ycarpan)+yy );
		}
		FonksiyonCiz.darea.QueueDraw();
	}
}